

#import "Hours_Lessons.h"
@implementation Hours_Lessons

- (id) init {
	self = [super init];
	if (self != nil) {
		Days = [[NSMutableArray alloc] init];
		lesson *less = [[lesson alloc]init]; 
		[less setLessonName:@"test" 
		 andlessonHourStart:@"08:00" 
		   andLessonHourEnd:@"10:00"
	   andLessonAssignments:@"Initial lesson assignment!"];
		
		day *Monday = [[day alloc]initWithDayName:@"Monday"];
		[Monday addLesson:less];
		[less release];
		day *tuesday = [[day alloc]initWithDayName:@"tuesday"];
		day *wednesday = [[day alloc]initWithDayName:@"Wednesday"];
		day *Thursday = [[day alloc]initWithDayName:@"Thurday"];
		day *Friday = [[day alloc]initWithDayName:@"Friday"];
		day *Saturday = [[day alloc]initWithDayName:@"Saturday"];
		day *Sunday = [[day alloc]initWithDayName:@"Sunday"];
		
		[Days addObject:Monday];
		[Days addObject:tuesday];
		[Days addObject:wednesday];
		[Days addObject:Thursday];
		[Days addObject:Friday];
		[Days addObject:Saturday];
		[Days addObject:Sunday];
		
		[Monday release];
		[tuesday release];
		[wednesday release];
		[Thursday release];
		[Friday release];
		[Saturday release];
		[Sunday release];
				
		currentDayID = 0; //Monday will be set as the first day
	}
	return self;
}

-(void)awakeFromNib
{
	printf("%i",[[daySelector selectedItem]tag]);
}

//______________________________________________________________________
-(int)numberOfRowsInTableView:(NSTableView *)tableView
{
	return [[[Days objectAtIndex:currentDayID] dayLessons]count];
}

-(id)tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *)tableColumn
		   row:(int)row
{
	NSString *identifier = [tableColumn identifier];
	lesson *item = [[[Days objectAtIndex:currentDayID]dayLessons]objectAtIndex:row];
	//NSLog(@"hello");
	[assignmentText setString: [item lessonAssignments]];
	return [item valueForKey:identifier];
}

-(void)tableView:(NSTableView *)tableView
  setObjectValue:(id)object
  forTableColumn:(NSTableColumn *)tableColumn
			 row:(int)row
{
	NSString *identifier = [tableColumn identifier];
	lesson *item = [[[Days objectAtIndex:currentDayID]dayLessons]objectAtIndex:row];
	[item takeValue:object forKey:identifier];
}

-(void)tableView:(NSTableView *)tableView didClickTableColumn:(NSTableColumn *)tableColumn
{
	NSString *identifier = [tableColumn identifier];
	NSLog(@"entering column function...\n");
	NSLog(@"%@",identifier);
	if ([identifier isEqualToString:@"lessonHourStart"]) {
		[[[Days objectAtIndex:currentDayID]dayLessons]sortUsingSelector:@selector(compareHourStart:)];
	}
	else if ([identifier isEqualToString:@"lessonHourEnd"]){
		[[[Days objectAtIndex:currentDayID]dayLessons]sortUsingSelector:@selector(compareHourEnd:)];
	}
	[dataContainer reloadData];

}
//________________________________________________________________________

-(IBAction)save:(id)sender
{
	NSSavePanel *savePanel = [NSSavePanel savePanel];
	SEL sel = @selector(savePanelDidEnd:returnCode:contextInfo:);
	[savePanel beginSheetForDirectory:@"~/Documents"
								 file:@"weekProgram.prg" 
					   modalForWindow:[dataContainer window]
						modalDelegate:self 
					   didEndSelector:sel
						  contextInfo:nil];
}

-(void)savePanelDidEnd:(NSSavePanel *)sheet
			returnCode:(int)returnCode
		   contextInfo:(void *)conext
{
	if(returnCode == NSOKButton){
		[NSArchiver archiveRootObject: Days toFile: [sheet filename]];
	}
}

-(IBAction)load:(id) sender
{
	NSOpenPanel *openPanel = [NSOpenPanel openPanel];
	SEL sel = @selector(openPanelDidEnd:returnCode:contextInfo:);
	[openPanel beginSheetForDirectory:@"~/Documents"
								 file:nil
								types:nil 
					   modalForWindow:[dataContainer window]
						modalDelegate:self
					   didEndSelector:sel
						  contextInfo:nil];
}


-(void)openPanelDidEnd: (NSOpenPanel *)sheet
			returnCode:(int)returnCode
		   contextInfo:(void *)contextInfo;
{
	if(returnCode == NSOKButton){
		NSMutableArray *array;
		array = [NSUnarchiver unarchiveObjectWithFile: [sheet filename]];
		[array retain];
		[Days release];
		Days = array;
		[dataContainer reloadData];
	}
}


//_________________________________________________________________________


-(IBAction)changeSelectedDay:(id)sender{
	currentDayID = [[daySelector selectedItem] tag];
	printf("%i",currentDayID);
	[dataContainer reloadData];
}

-(IBAction)addLesson:(id)sender
{
	lesson *less = [[lesson alloc]init];
	[less setLessonName:@"LessonName" 
	 andlessonHourStart:@"<0-0>"
	   andLessonHourEnd:@"<0-0>"
   andLessonAssignments:@"No Assignments have been recorded yet..."];
	[[Days objectAtIndex:currentDayID]addLesson:less];
	[less release];
	[dataContainer reloadData];
}

-(IBAction)removeLesson:(id)sender
{
	[[[Days objectAtIndex:currentDayID]dayLessons]removeObjectAtIndex:[dataContainer selectedRow]];
	[dataContainer reloadData];
}

-(IBAction)addAssignment:(id)sender
{
	lesson *less = [[[Days objectAtIndex:currentDayID]dayLessons]objectAtIndex:[dataContainer selectedRow]];
	[less takeValue:[assignmentText string] forKey:@"lessonAssignments"];
}

-(IBAction)moveUp:(id)sender{
	NSLog(@"moving selected item up...\n");
	//unsigned elements = [self numberOfRowsInTableView:dataContainer];
	unsigned index1 = [dataContainer selectedRow];
	printf("%i",index1);
	
	
	unsigned index2 = index1 - 1;
	[[[Days objectAtIndex:currentDayID]dayLessons] exchangeObjectAtIndex:index1 withObjectAtIndex:index2];
	[dataContainer reloadData];
	[dataContainer selectRow:index2 byExtendingSelection:NO];
}

-(IBAction)moveDown:(id)sender{
	NSLog(@"moving selected item down...\n");
	unsigned index1 = [dataContainer selectedRow];
	unsigned index2 = index1 + 1;

	[[[Days objectAtIndex:currentDayID]dayLessons] exchangeObjectAtIndex:index1 withObjectAtIndex:index2];
	[dataContainer reloadData];
	[dataContainer selectRow:index2 byExtendingSelection:NO];
}


-(IBAction)showItemInfo:(id)sender
{
	//NSString *str = [[NSString alloc] initWithString:[[[[Days objectAtIndex:currentDayID]dayLessons]objectAtIndex:[dataContainer selectedRow]]lessonAssignments]];
	
	[[[[Days objectAtIndex:currentDayID]dayLessons]objectAtIndex:[dataContainer selectedRow]]display];
	
}

- (void) dealloc {
	[Days release];
	[super dealloc];
}

@end